{-----------------------------------------------------------------------------}
{ Expression handling.                                           (c) 1992 YGP }

    const _e_dummy =  $08;                     { dummy patch (inside section) }

	  _e_mask   = $f0;           { _e_xx = %ABCDEFGH -  , : }
          _e_ident  = $00;     {  ABC -> 00 -     }
          _e_branch = $10;                                     { branch patch }
          _e_lobyte = $20;                                    { lo byte patch }
	  _e_word   = $30;                                  { (lo) word patch }
	  _e_words  = $40;                  { (lo) words patch (with counter) }
	  _e_lobts  = $50;	            { (lo) bytes patch (with counter) }
	  _e_usrerr = $f0;                                  { directive error }

	  _e_errno = $07; {  FGH -> 1..7+p_err =     }

    var gv:  value;
        wid: identifier;    { work variable for forward identifer declaration }
        ex:  expr_ptr;
        wlst: ex_lstp;

    function make_value((*)const{*)var{*} fv: value): valuep;
      var vp: valuep;
    begin { make_value }
      case fv.v_kind of
        v_err,
        v_none: vp:= nil;                            {      }

        v_cnst: begin
          if fv.l >= 0 then begin
            if fv.l <= 255 then begin                          {$ifdef use_new}
              new(vp (*), v_byte(*));                                   {$else}
              (*) getmemwords(vp, value_sizes[v_byte]);
              {*) new(vp);                              {*}            {$endif}
              vp^.v_kind:= v_byte; vp^.b:= fv.l; end
            else if fv.l <= 65535 then begin                   {$ifdef use_new}
              new(vp (*), v_word(*));                                   {$else}
              (*) getmemwords(vp, value_sizes[v_word]);
              {*) new(vp);                              {*}            {$endif}
              vp^.v_kind:= v_word; vp^.w:= fv.l; end
            end
          else if -65536 <= fv.l then begin                    {$ifdef use_new}
            new(vp (*), v_negw(*));                                     {$else}
            (*) getmemwords(vp, value_sizes[v_negw]);
            {*) new(vp);                              {*}              {$endif}
            vp^.v_kind:= v_negw; vp^.w:= fv.l; end
          else begin                                           {$ifdef use_new}
            new(vp (*), v_cnst(*));                                     {$else}
            (*) getmemwords(vp, value_sizes[v_cnst]);
            {*) new(vp);                              {*}              {$endif}
            vp^.v_kind:= v_cnst; vp^.l:= fv.l;
          end { if };
	end { when constant };

	v_expr: begin
	  vp:= fv.e;
	end { when v_expr };

      else (*):(*)  {        v_byte, v_word, ... }
                                                              {$ifNdef use_new}
        (*) getmemwords(vp, value_sizes[fv.v_kind]);
        {*) new(vp);                              {*}                  {$endif}
	if fv.v_kind < v_op_add then begin
	  unimplemented('make op'); error(se_mkv); end
        else if fv.v_kind < v_op_not then begin                {$ifdef use_new}
          new(vp (*), v_op_add(*));                                    {$endif}
	  vp^.v_kind:= fv.v_kind;
	  vp^.l_op:= fv.l_op; vp^.r_op:= fv.r_op; end
        else if fv.v_kind < v_expr then begin                  {$ifdef use_new}
          new(vp (*), v_op_not(*));                                    {$endif}
	  vp^.v_kind:= fv.v_kind;
	  vp^.s_op:= fv.s_op; end
	else begin
	  unimplemented('make op'); error(se_mkv);
	end { if };
      end { case };
      make_value:= vp;
    end { make_value };

    procedure free_value(var vp: valuep);
    begin { free_value }
      if vp <> nil then begin
        (*) freememwords(vp, value_sizes[vp^.v_kind]);
        {*) dispose     (vp);                      {*}
	vp:= nil;
      end { if };
    end { free_value };

    procedure get_id_value(fidp: idp; var fv: value);
    begin { get_id_value }
      gv.v_kind:= v_cnst;
      case fidp^.id_type of
	id_undeclared: begin
	  gv.v_kind:= v_none;
	end { if };

        id_expression, id_forward: begin
	  {     expression     }
	  if ex = nil then begin
	    new(ex);
	    with ex^ do begin
	      expr:= nil;
	      line:= get_lno;
	      f_no:= get_fno;
	      bump_fusage;
	    end { with };
	  end { if };
          new(wlst);
	  (* ) writeln; writeln('new pointer: ', swap(wlst)); ( *)
          wlst^.expr:= ex; wlst^.next:= fidp^.elst;
          fidp^.elst:= wlst;
	  fv.v_kind:= v_expr;
          new(fv.e(*), v_fwrd(*));
          fv.e^.v_kind:= v_fwrd; fv.e^.id:= fidp;
        end { when expression or forward declared label };

	(*
        id_byte: fv.l:= fidp^.bval;
	*)

        id_word: fv.l:= fidp^.wval;

        id_nword: fv.l:= fidp^.wval or $ffff0000;

      else (*):(*)
	unimplemented('id_type_in_expr');
      end { case };
    end { get_id_value };

    function get_cnst((*)const{*)var{*} v: value): longint;
    begin { get_cnst }
      case v.v_kind of
        v_cnst: get_cnst:= v.l;
        v_byte: get_cnst:= v.b;
        v_word: get_cnst:= v.w;
        v_negw: get_cnst:= v.w or $ffff0000;
      end { case };
    end { get_cnst };

    function calc_op(lop: valuep; fop: val_kinds; rop: valuep;
                     var rv: value): boolean;
    begin { calc_op }
      {      fop,    l_op  r_op  }
      {   rv:= l_op fop r_op   ()  .   }
      {      (            }
      {  .            }
      {      .     rv.v_kind:= v_err.   }
      {         (    ).               }
      calc_op:= true;
      if fop < v_op_add then
        error(se_calc)
      else if fop < v_op_not then begin               {   }
        if (lop = nil) or (rop = nil) or
           (lop^.v_kind <= v_none) or (rop^.v_kind <= v_none) then
          rv.v_kind:= v_none
        else begin
	  if (lop^.v_kind >= (* v_expr *) v_op_add ) or
	     (rop^.v_kind >= (* v_expr *) v_op_add ) then begin
            calc_op:= false; (*) return() {*) exit {*};
          end { if };

          if (lop^.v_kind < v_real) and (rop^.v_kind < v_real) then begin
            rv.v_kind:= v_cnst;
            case fop of
              v_op_add: rv.l:= get_cnst(lop^) + get_cnst(rop^);
	      v_op_sub: rv.l:= get_cnst(lop^) - get_cnst(rop^);
	      v_op_mul: rv.l:= get_cnst(lop^) * get_cnst(rop^);
	      v_op_and: rv.l:= longword(get_cnst(lop^)) and get_cnst(rop^);
	      v_op_or:  rv.l:= longword(get_cnst(lop^)) or  get_cnst(rop^);
	      v_op_xor: rv.l:= longword(get_cnst(lop^)) xor get_cnst(rop^);
	      v_op_lt:  rv.l:=-ord(longword(get_cnst(lop^)) <  get_cnst(rop^));
	      v_op_gt:  rv.l:=-ord(longword(get_cnst(lop^)) >  get_cnst(rop^));
	      v_op_le:  rv.l:=-ord(longword(get_cnst(lop^)) <= get_cnst(rop^));
	      v_op_ge:  rv.l:=-ord(longword(get_cnst(lop^)) >= get_cnst(rop^));
	      v_op_ne:  rv.l:=-ord(longword(get_cnst(lop^)) <> get_cnst(rop^));
	      v_op_eq:  rv.l:=-ord(longword(get_cnst(lop^)) =  get_cnst(rop^));

	      v_op_div, v_op_mod: begin
		rv.l:= get_cnst(rop^);
		if rv.l = 0 then
		  error(e_divzer)
		else begin
		  if fop = v_op_div then
		    rv.l:= get_cnst(lop^) div rv.l
		  else begin
		    rv.l:= get_cnst(lop^) mod rv.l
		  end { if };
		end { if };
	      end { when div/mod };

            else (*):(*)
              unimplemented('calc op');
            end { case }; end
          else begin
	    unimplemented('1 calc op');
          end { if };
        end { if }; end
      else if fop < v_expr then begin                {   }
	if (lop = nil) or (lop^.v_kind <= v_none) then
          rv.v_kind:= v_none
        else begin
	  if lop^.v_kind >= v_expr then begin
            calc_op:= false; (*) return() {*) exit {*};
          end { if };

	  if lop^.v_kind < v_real then begin
            rv.v_kind:= v_cnst;
            case fop of
	      v_op_neg: rv.l:= -get_cnst(lop^);
	      v_op_not: rv.l:= longword(get_cnst(lop^)) xor $ffffffff;

	      v_hi_bt: rv.l:= hi(gv.l);

            else (*):(*)
              unimplemented('2 calc op');
            end { case }; end
          else begin
	    unimplemented('3 calc op');
          end { if };
        end { if }; end
      else begin
        unimplemented('4 calc op');
      end { if };
    end { calc_op };

    procedure expression(str  { allow strings },
                         fp   { use fp arithmetic },
                         as11 { as11 compatibality }: boolean);
      var s: string; wv: value;

      procedure do_double(var fv: value; fop: val_kinds);
      begin
	if calc_op(addr(fv), fop, addr(gv), wv) then
	  gv:= wv
	else begin
	  wv.v_kind:= fop;
	  wv.l_op:= make_value(fv);
	  wv.r_op:= make_value(gv);
	  gv.v_kind:= v_expr; gv.e:= make_value(wv);
	end { if };
      end { do_double };

      procedure do_single(fop: val_kinds);
      begin
        if calc_op(addr(gv), fop, nil, wv) then
	  gv:= wv
	else begin
	  wv.v_kind:= fop;
          wv.l_op:= make_value(gv);
	  gv.v_kind:= v_expr; gv.e:= make_value(wv);
	end { if };
      end { do_single };

      procedure expr(fp: boolean);

        procedure s_expr;

          procedure term;

            procedure factor;
              var lsy: symbol; lidp: idp;
            begin { factor }
              gv.v_kind:= v_none;

              case sy of
                quote,
                dquote: get_string(s);

              else(*):(*)
                if not (sy in [asterisk, ident, not_sy,
                               l_par, constant]) then begin
		  error(e_factor); (*) return; {*) exit; {*}
                end { if };
              end { case };

              (* BUG if as11 = true. corrected in v5.06

              if sy = ident then begin    {     }
                wsize:= pack_size; wname:= pack_name;         {    }
              end { if };
              lsy:= sy; insy; *)

              case sy of
                ident: begin
                                         {     }
                  wsize:= pack_size; wname:= pack_name;
                  insy;

                  if sy = l_par then begin                   {   }
                    unimplemented('pseudo function'); end
                  else begin
                    lidp:= find_lab(wsize, wname);  {     ident }
                    if lidp = nil then begin        {      }
		      fillchar(wid, sizeof(wid), #0);
		      wid.id_type:= id_forward;
						     {     with
                      with wid do begin
                        id_type:= id_forward; ex:= nil; cd:= nil;
                      end { with };
                      if lvl = nil then
                        lidp:= insert_lab(wsize, wname, wid, global_labs)
                      else begin
                        lidp:= insert_lab(wsize, wname, wid, lvl^.labs)
                      end { if };
                    end { if };
		    {      }
		    lidp^.id_flags:= lidp^.id_flags or _id_used;
                    get_id_value(lidp, gv);

                    (*    
                    (*gv.v_kind:= v_cnst;
                    (*case lidp^.id_type of
                    (*
                    (*  id_expression, id_forward: begin
                    (*    new(wlst);
                    (*    wlst^.expr:= ex; wlst^.next:= lidp^.elst;
                    (*    lidp^.elst:= wlst;
                    (*    gv.v_kind:= v_expr;
                    (*    new(gv.e);
                    (*    gv.e^.v_kind:= v_fwrd; gv.e^.id:= lidp;
                    (*  end { when expression or forward declared label };
                    (*
                    (*  id_byte: gv.l:= lidp^.bval;
                    (*
                    (*  id_word: gv.l:= lidp^.wval;
                    (*
                    (*else:
                    (*  unimplemented('id type in expr');
                    (*end { case };
                    *)
                  end { if };
                end { when ident };

		asterisk: begin                    {    APC }
		  if (c_flags and (_c_section +
				   _c_obj_file+ _c_pgm_file+
				   _c_bin_file+ _c_cmd_file) = 0) then
		    error(e_fkind)
		  else if _APC._mod = 0 then begin
		    gv.l:= _APC.pc; gv.v_kind:= v_cnst; end
		  else begin
		    unimplemented('express - *');
		  end { if };
                  insy;
                end { when * };

                string_sy: begin
                  if not str then
                    error(e_no_str)
                  else begin
                    gv.v_kind:= v_str;
		    (*) getmemwords(gv.s, length(s) div 2 +1);
		    {*) getmem(gv.s, length(s) +1); {*}
		    move(s, gv.s^, length(s)+1);
                  end { if };
                  insy;
                end { when string };

                constant: begin
                  if fp then begin
                    gv.v_kind:= v_real; gv.r:= lastreal; end
                  else if c_flags and _c_real_only <> 0 then
                    error(e_cnst2lrg)
                  else begin
                    gv.v_kind:= v_cnst; gv.l:= lastlint;
                  end { if };
                  insy;
                end { when constant };

                not_sy: begin
                  insy;
                  factor;
                  do_single(v_op_not)
                end { when not };

                l_par: begin
                  insy;
                  expr(fp);
                  if sy = r_par then
                    insy
                  else begin
                    error(e_r_par);
                  end { if };
                end { when ( };
              end { case };
            end { factor };

	    var lop: val_kinds; lv: value;
          begin { term }
            factor;
            while sy in [asterisk, slash_sy, bslash_sy,
                         and_sy, percent_sy] do begin
	      lv:= gv;
	      case sy of
		asterisk:  lop:= v_op_mul;
		slash_sy:  lop:= v_op_div;
		and_sy:    lop:= v_op_and;
                percent_sy,
		bslash_sy: lop:= v_op_mod;
	      end { case };
	      insy; factor; do_double(lv, lop);
            end { while };
          end { term };

	  var lop: val_kinds; neg: boolean; lv: value;
        begin { s_expr }
          neg:= false;                        {    (+  -) }
          if sy in [plus_sy, minus_sy] then begin
            neg:= sy = minus_sy; insy;
          end { if };

	  term;                                            {  term }
	  if neg then begin
            do_single(v_op_neg);
          end { if };

          while sy in [plus_sy, minus_sy, or_sy, xor_sy] do begin
	    lv:= gv;
	    case sy of
	      plus_sy:  lop:= v_op_add;
	      minus_sy: lop:= v_op_sub;
	      or_sy:    lop:= v_op_or;
	      xor_sy:	lop:= v_op_xor;
	    end { case };
	    insy; term; do_double(lv, lop);
          end { while };
        end { s_expr };

	  var lop: val_kinds; lv: value;
      begin { expr }
        s_expr;                               {  simple expression }
        if sy in [less_sy, great_sy, equ_sy, leq_sy, geq_sy, neq_sy] then begin
	  lv:= gv;
	  case sy of
	    less_sy:  lop:= v_op_lt;
	    great_sy: lop:= v_op_gt;
	    equ_sy:   lop:= v_op_eq;
	    leq_sy:   lop:= v_op_le;
	    geq_sy:   lop:= v_op_ge;
	    neq_sy:   lop:= v_op_ne;
	  end { case };
	  insy; s_expr; do_double(lv, lop);
        end { if };
      end { expr };

    begin { expression,       (.. ) }
      gv.v_kind:= v_none; ex:= nil;
      case sy of
        slash_sy: begin
	  insy; expr(fp);    {        hi }
          do_single(v_hi_bt);
        end { when / };

      else(*):(*)
        expr(fp);
      end { case };

      if gv.v_kind = v_expr then begin
        ex^.expr:= gv.e; gv.ex:= ex;
        gv.ex^.kind:= _e_dummy+_e_lobyte;{  lst      }
      end { if };

      if not (sy in [comma, l_bra, r_bra, dies,
                     eol_sy, eof_sy, comment_line]) and not as11 then begin
        error(e_express);
      end { if };
    end { expression };

    function check_expression(ex_p: expr_ptr; oidp, nidp: idp;
                              var fid: identifier): idp;
      var not_found, is_cnst: boolean; wv: value; single_op: boolean;

      procedure search(var vp: valuep);
      begin { search expression tree and calc it (if possible) }
        if vp <> nil then begin
	  if (vp^.v_kind >= v_expr) and (vp^.id = oidp) then begin
            get_id_value(nidp, gv); free_value(vp);   {    }
	    is_cnst:= true; not_found:= false; end  {  ,    }
	  else if vp^.v_kind >= v_op_add then begin
	    {   () (),       -}
	    { ,  ,     ,  -}
	    { ,     .                                }

	    if vp^.v_kind >= v_op_not then begin
	      search(vp^.s_op);
	      if is_cnst then begin
		if not calc_op(addr(gv), vp^.v_kind, nil, wv) then begin
		  if gv.v_kind = v_err then
		    unimplemented('error backword')
		  else begin
		    vp^.s_op:= make_value(gv); is_cnst:= false;
		  end { if }; end
		else begin {       }
		  gv:= wv;             {      }
		  free_value(vp);                               {   }
		end { if };
	      end { if }; end
	    else begin
	      search(vp^.l_op);                    {    , }
	      if is_cnst then begin
		if not calc_op(addr(gv), vp^.v_kind, vp^.r_op, wv) then begin
		  if gv.v_kind = v_err then
		    unimplemented('error backword')
		  else begin
		    vp^.l_op:= make_value(gv); is_cnst:= false;
		  end { if }; end
		else begin  {       }
		  gv:= wv;           {      }
		  free_value(vp^.r_op); free_value(vp); {    }
		end { if };                        {      }
	      end { if };

	      if not_found and (vp^.v_kind < v_op_not) then begin    {  }
		search(vp^.r_op);    {      }
		if is_cnst then begin      {   (   ) }
		  if not calc_op(vp^.l_op, vp^.v_kind, addr(gv), wv) then begin
		    if gv.v_kind = v_err then
		      unimplemented('error backword')
		    else begin
		      vp^.r_op:= make_value(gv); is_cnst:= false;
		    end { if }; end
		  else begin{       }
		    gv:= wv;         {      }
		    free_value(vp^.l_op); free_value(vp);{   }
		  end { if };                      {      }
		end { if };
	      end { if };
            end { if };
          end { if };
        end { if };
      end { search };

    begin { check_expression }
      {        oidp (  forward) }
      {       nidp.      }
      {       .       }
      {   ,          }
      {        (fid)    () }

      check_expression:= nil; not_found:= true; is_cnst:= false;
      ex:= ex_p;          {    (      ) }
      search(ex_p^.expr);
      if not_found then begin
        if (ex_p^.expr <> nil) then
	  error(se_ce)
        else begin {   (  NIL)        
           forward         .
               ,    . }
        end { if };
      end { if };
      if is_cnst then begin    {          }
	    {      (    ). }
                                                         {$ifdef id_correction}
        if l_flags and _l_pass = 0 then begin
          writeln('kind: ', (*){*)b2s{*}(ex_p^.kind),
                  ', line: ', ex_p^.line+1: 5,
                  ', offset: ', (*)word{*)w2s{*}(ex_p^.offs));
        end { if };
                                                                       {$endif}
        case ex_p^.kind and _e_mask of
	  _e_ident: begin
	    check_expression:= ex_p^.eidp;
	    with fid do begin
	      id_flags:= 0;
	      if gv.v_kind = v_cnst then begin
		if (gv.l < -65536) or (65536 <= gv.l) then begin
		  id_type:= id_lint; lval:= gv.l; end
		else if gv.l >= 0 then begin
		  id_type:= id_word; wval:= gv.l; end
		else begin
		  id_type:= id_nword; wval:= loword(gv.l);
		end { if }; end
	      else begin
		unimplemented('correction identifier decl');
	      end { if };
	    end { with };
          end { when correct identifier };
                                                                  {$ifNdef lst}
          _e_branch: begin                                     { branch patch }
                {             }
                { byte patch        .         }
            if gv.v_kind = v_cnst then begin
	      if (127 < gv.l) or (gv.l < $ffffff80) then
		ferror(ex_p^.f_no, ex_p^.line, e_outrng)
              else if ex_p^.kind and _e_dummy = 0 then begin
                change_byte(ex_p^.offs, gv.l)
              end { if }; end
            else begin     {           }
                                             {       }
              unimplemented('non cnst when branch patch');
            end { if };
          end { when branch patch };

          _e_lobyte: begin
            if gv.v_kind = v_cnst then begin
              if ex_p^.kind and _e_dummy = 0 then begin
                change_byte(ex_p^.offs, gv.l);
              end { if };
              if (ex_p^.kind and _e_errno <> 0) and
		 ((gv.l < -128) or (255 < gv.l)) then begin
		if (shortcard(ex_p^.kind and _e_errno) <= 5) then
		  ferror(ex_p^.f_no, ex_p^.line, ex_p^.kind and _e_errno)
                else begin
		  ferror(ex_p^.f_no, ex_p^.line,
                        shortcard(ex_p^.kind and _e_errno) + e_patched)
                end { if };
              end { if }; end
            else begin     {           }
                                             {       }
              unimplemented('non cnst when byte patch');
            end { if };
          end { when lo byte patch };

	  _e_words: begin
            if gv.v_kind = v_cnst then begin
	      if ex_p^.kind and _e_dummy = 0 then begin
		unimplemented('words patch');
		{      (wv.l)    }
		while wv.l > 0 do begin
		  dec(wv.l); change_word(ex_p^.offs+0, gv.l);
		end { while };
              end { if }; end
            else begin     {           }
                                             {       }
	      unimplemented('non cnst when words patch');
            end { if };
	  end { when words to be generated };

          _e_word: begin
            if gv.v_kind = v_cnst then begin
              if ex_p^.kind and _e_dummy = 0 then begin
		change_word(ex_p^.offs+0, gv.l);
              end { if };
              if (ex_p^.kind and _e_errno <> 0) and
		 ((gv.l < -32768) or (65535 < gv.l)) then begin
		if (shortcard(ex_p^.kind and _e_errno) <= 5) then
		  ferror(ex_p^.f_no, ex_p^.line, ex_p^.kind and _e_errno)
                else begin
		  ferror(ex_p^.f_no, ex_p^.line,
                         shortcard(ex_p^.kind and _e_errno) + e_patched)
                end { if };
              end { if }; end
            else begin     {           }
                                             {       }
              unimplemented('non cnst when word patch');
            end { if };
	  end { when word patch };

	  _e_usrerr: begin
	    if gv.l <> 0 then begin
	      ferror(ex_p^.f_no, ex_p^.line, e_usr_error);
	    end { if };
	  end { e_error };

	else(*):(*)
	  unimplemented('patch case');
                                                                       {$endif}
	end { case };

	dec_fusage(ex_p^.f_no, false);{ ,       }
	dispose(ex_p);     { -       }
      end { if };
    end { check_expression };

{-----------------------------------------------------------------------------}
